class PackingListController < ApplicationController
   before_action :require_login
   before_action :allowed_pages
   before_action :is_allowed_location
   skip_before_action :verify_authenticity_token,:only=> [:ajax_process]
   include ErpModule::Common
   helper_method :currency_formatted
   
  def index
    @compcodes            =  session[:loggedUserCompCode]
    @logedId              =  session[:autherizedUserId]
    @xLoc                 =  session[:autherizedLoc]
    @isFlags              =  false
    @cdate                =  Time.now.strftime('%d-%b-%Y')
    params[:hd_sale_type] = 'S'
    params[:hd_type]      = 'Local'   
    @compObj              =  MstCompany.select("cmp_companycode,cmp_companyname").all.order('cmp_companyname ASC')
    month_number          =  Time.now.month
    month_begin           =  Date.new(Date.today.year, month_number)
    begdate               =  Date.parse(month_begin.to_s)
    @nbegindate           =  begdate.strftime('%d-%b-%Y')
    month_ending          =  month_begin.end_of_month
    endingDate            =  Date.parse(month_ending.to_s)
    @enddate              =  endingDate.strftime('%d-%b-%Y')    
    @LastOABills          =  get_orderno_details
    @LastPackNo           =  get_last_pack_number
    @AllPackList          =  get_packlist_all_bills
    @HeadPack             =  nil
    @FootPack             =  nil
    @Customer             =  nil
    @printpath            =  nil
    @rootUrl              =  "#{root_url}"
    ################### PROCESS PACK LISTING Settings################
     if params[:id]!=nil && params[:id]!=''
         dparmes  = params[:id].split("_")
        if dparmes[1]!='PLC'
          nlid      = Base64.decode64(params[:id])
          prntid    = params[:id]
          plid      = nlid.split("_")
          pnnumber  = plid[0]
          comxcode  = plid[1]
          typecode  = plid[2]
          @HeadPack = TrnPackingList.where("pl_compcode=? AND pl_number=? AND pl_local_type=?",comxcode,pnnumber,typecode).first
          oanumber  = @HeadPack.pl_oa_number
          @FootPack = TrnPackingListDetail.where("pld_compcode=? AND pld_number=? AND pld_locality_type=?",comxcode,pnnumber,typecode)
          @Customer = TrnProformaHdr.select("hd_invoiceto,hd_dispmode,hd_billnumber,hd_po_number").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_type=? AND hd_billnumber=?", comxcode,params[:hd_sale_type],typecode,oanumber]).first
          session[:isprintableid] = prntid
          printcontroll    = pnnumber.to_s+"_PLC_"+pnnumber.to_s+"_pcklist_report"
          @printpath       = packing_list_path(printcontroll,:format=>"pdf")

        end
        if dparmes[1]=='PLC'
          nlid      = Base64.decode64(session[:isprintableid])         
          plid      = nlid.split("_")
          pnnumber  = plid[0]
          comxcode  = plid[1]
          typecode  = plid[2]
          @compDetail= MstCompany.where(["cmp_companycode = ?", @compcodes]).first
          @HeadPack = TrnPackingList.where("pl_compcode=? AND pl_number=? AND pl_local_type=?",comxcode,pnnumber,typecode).first
          oanumber  = @HeadPack.pl_oa_number
          @FootPack = TrnPackingListDetail.where("pld_compcode=? AND pld_number=? AND pld_locality_type=?",comxcode,pnnumber,typecode)
          @Customer = TrnProformaHdr.select("hd_invoiceto,hd_dispmode,hd_billnumber,hd_po_number,hd_station").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_type=? AND hd_billnumber=?", comxcode,params[:hd_sale_type],typecode,oanumber]).first
           if @FootPack.length >0
              respond_to do |format|
                format.html
                  format.pdf do
                      pdf = PacklistingPdf.new(@FootPack,@HeadPack,'',@compDetail,@Customer,@rootUrl,'','',session,'')
                      send_data pdf.render,:filename => "1_"+pnnumber.to_s+"_pack_report.pdf", :type => "application/pdf", :disposition => "inline"
                  end
             end
           end
        end
      
      end
    ####################################
   
    session[:generatecustid] = nil
    session[:generateshipid] = nil
    
end
def create
   @compcodes  =  session[:loggedUserCompCode]
   @logedId    =  session[:autherizedUserId]
   comp_codes  =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
   comp_type   =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] :'Local'
   isFlags     =  true
   begin
   if params[:hd_company]=='' || params[:hd_company]==nil
          flash[:error] =  "Please select company"
          isFlags       =  false
    elsif params[:hd_type]=='' || params[:hd_type]==nil
          flash[:error] =  "Please select type"
          isFlags       =  false
    elsif params[:pl_number]=='' || params[:pl_number]==nil
          flash[:error] =  "Pack list number is required"
          isFlags       =  false
    elsif params[:pl_date]=='' || params[:pl_date]==nil
          flash[:error] =  "Please enter packlist date"
          isFlags       =  false
    elsif params[:pl_oa_number]=='' || params[:pl_oa_number]==nil
          flash[:error] =  "Please select OA/EPS No"
          isFlags       =  false
    else
        headermid   =  params[:headerid]!=nil && params[:headerid]!='' ? params[:headerid].delete(' ') : 0
        plnumber    =  params[:pl_number]!=nil && params[:pl_number]!='' ? params[:pl_number].delete(' ') : 0        
        if isFlags
          packobj = TrnPackingList.where("pl_compcode=? AND pl_number=? AND pl_local_type=?",comp_codes,plnumber,comp_type)
          if packobj.length >0
              upobj  = TrnPackingList.where("pl_compcode=? AND id=?",comp_codes,headermid).first
              if upobj
                 upobj.update(save_pack_listing)
                  process_grid_data(plnumber)
                   flash[:error] = "Data updated successfully."
                   isFlags       = true
              end
          else

              pobj =  TrnPackingList.new(save_pack_listing)
              if params[:isprocessedupdated]!=nil && params[:isprocessedupdated]!='' && params[:isprocessedupdated]=='Y' && params[:pl_number].to_i >0
                  pld_number = params[:pl_number]
                else
                  pld_number  = @sumOfCode
                end
              if pobj.save                  
                  process_grid_data(pld_number)
                  flash[:error] = "Data saved successfully."
                  isFlags       = true
              end
          end
         
           
        end
   end
   if !isFlags
     session[:isErrorhandled] = 1
   else
     session[:postedpamams]   = nil
     session[:isErrorhandled] = nil
     session.delete(:postedpamams)
   end
   rescue Exception => exc
      flash[:error]              = "#{exc.message}"
      session[:isErrorhandled]   = 1
      session[:canceldeletebill] = dt_billnumber = params[:pl_number]
      if params[:isprocessedupdated]!=nil && params[:isprocessedupdated]!='' && params[:isprocessedupdated]!='Y'
        rollback_billing_if_not_acl(dt_billnumber)
      end      
   end
   redirect_to "#{root_url}"+"packing_list"   
end

def show
  @compcodes    = session[:loggedUserCompCode]
  @rootUrl      = "#{root_url}"
  @compDetail   = MstCompany.where(["cmp_companycode = ?", @compcodes]).first
   @isXProd     = get_print_selected_product()
   arr          = []
   @isPran      = MstPrnquoation.all
   if @isXProd.length >0
     @isXProd.each do |itms|
       arr.push itms
     end
     isconts = @isXProd.length
     fcont   = 12-isconts
     for i in 1..fcont
           @isPran.each do |pcx|
           arr.push pcx
          end
     end
     @isXProd = arr
   end

   if @isXProd.length >0
           respond_to do |format|
              format.pdf do
               pdf = QuotationPdf.new(@isXProd,@isCustState,@isShipto,@compDetail,@cstType,@rootUrl,@isProforma,@isTakeTax,@isGstNumbers,'','')
               #line_items
               send_data pdf.render,:filename => "1/"+params[:bill_number].to_s+"_quotation_report.pdf", :type => "application/pdf", :disposition => "inline"
            end
         end
   end
end

def ajax_process
  @compcodes = session[:loggedUserCompCode]
  if params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='TRNLP'
     get_last_order_details()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='CUSTOMER'
     get_customer_details()
     return
  elsif params[:isProductName]!=nil &&  params[:isProductName]!='' && params[:isProductName]=='OAN'
     get_search_prdname_by_oano()
     return
  end
  
end

def packing_list_refresh 
 session[:postedpamams]    = nil
 session[:isErrorhandled]  = nil
 session[:hd_billdate]     = nil
 session[:hd_invoiceto]    = nil
 session[:hd_customer_id]  = nil
 session[:hd_refnumber]    = nil
 session[:hd_refnumber]    = nil
 session.delete(:isErrorhandled)
 session.delete(:postedpamams)
 redirect_to "#{root_url}"+"packing_list"
end

private
def get_orderno_details
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
     if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
     end
  end
 objitem =  TrnProformaHdr.select("hd_billnumber").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_loc = ? AND hd_type=?", comp_codes,params[:hd_sale_type].to_s,@isLoc.to_s,params[:hd_type]]).order('hd_billnumber desc')
 return objitem
end

private
def get_last_pack_number 
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
  end
  @isCode    = 0
  @Startx    = '0000'
  @recCodes  = TrnPackingList.where(["pl_compcode = ? AND pl_number >0 AND pl_local_type=?", comp_codes,params[:hd_type]]).order('pl_number DESC').first
  if @recCodes
   @isCode  = @recCodes.pl_number.to_i
  end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_i < 10
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >5
      @sumXOfCode =  @sumXOfCode.to_i
    end
end

private
def get_last_order_details
   compname               = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : ''
   xtype                  = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : ''
   params[:hd_type]       = xtype
   params[:hd_sale_type]  = 'S'
   params[:comp_codes]    = compname
   isstatus               = false;
   get_last_pack_number
   alloano     = get_proforma_all_bills()
   allob       = []
   lastbillno  = ''

   if @sumXOfCode
       lastbillno = @sumXOfCode
       isstatus   = true
       allob     =  get_packlist_all_number()
   end

  respond_to do |format|
    format.json { render :json => { 'data'=>allob,"lastbillno"=>lastbillno,"alloano"=>alloano,"message"=>'',:status=>isstatus } }
  end

end

private
def get_proforma_all_bills 
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
     if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
     end
  end
 objitem =  TrnProformaHdr.select("hd_billnumber").where(["hd_compcode = ? AND hd_sale_type= ? AND hd_loc = ? AND hd_type=?", comp_codes,params[:hd_sale_type].to_s,@isLoc.to_s,params[:hd_type]]).order('hd_billnumber desc')
 return objitem
end

def get_packlist_all_bills  
  comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
  if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
     if comp_codes == nil ||  comp_codes == ''
       comp_codes = @compcodes
     end
  end
 objitem =  TrnPackingList.select("pl_number,id,pl_compcode,pl_local_type").where(["pl_compcode = ? AND pl_sale_type=? AND pl_local_type=?", comp_codes,params[:hd_sale_type],params[:hd_type]]).order('pl_number desc')
 return objitem
end





private
def get_packlist_all_number 
   comp_codes  = params[:comp_codes]!=nil && params[:comp_codes]!='' ? params[:comp_codes] : ''
   if  params[:hd_type]!=nil && params[:hd_type]!= '' && params[:hd_type] == 'Local'
       if comp_codes == nil ||  comp_codes == ''
         comp_codes = @compcodes
       end
   end
   arr     = []
   objitem =  TrnPackingList.select("pl_number,'' as newpl_number,pl_local_type,id").where(["pl_compcode = ? AND pl_sale_type= ? AND pl_local_type=?", comp_codes,params[:hd_sale_type],params[:hd_type]]).order('pl_number DESC')
  if objitem.length >0
      objitem.each do |plsd|
        plsd.newpl_number = Base64.encode64(plsd.pl_number+"_"+comp_codes.to_s+"_"+ plsd.pl_local_type.to_s)
        arr.push plsd
      end
      
  end

  return arr
end

private
def get_customer_details()
   compname    = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : ''
   xtype       = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : ''
   oanumber    = params[:oanumber]!='' && params[:oanumber]!=nil ? params[:oanumber] : ''
  #jons          = " JOIN mst_customers cst ON(cst.id=hd_customer_id AND cst.cs_compcode=hd_compcode)"
  obj    = TrnProformaHdr.select("hd_invoiceto,hd_dispmode,hd_billnumber,hd_po_number").where("hd_compcode=? and hd_billnumber=? and hd_type=?",compname,oanumber,xtype).first
  respond_to do |format|
    format.json { render :json => { 'data'=>obj,"message"=>'',:status=>true } }
  end

end ## END IF

private
def get_search_prdname_by_oano
    compname    = params[:compname]!='' && params[:compname]!=nil ? params[:compname] : @compcodes
    xtype       = params[:xtype]!='' && params[:xtype]!=nil ? params[:xtype] : 'Local'
    oanumber    = params[:oanumber]!='' && params[:oanumber]!=nil ? params[:oanumber] : ''
    iswhere     = "hd_compcode = '#{compname}'"
    if xtype!=nil && xtype!=''
       iswhere  += " AND hd_type ='#{xtype}'"
    end
     if oanumber!=nil && oanumber!=''
       iswhere  += " AND hd_billnumber='#{oanumber}'"
     end
     if params[:productname]!='' && params[:productname]!=nil
        productname = params[:productname]+"%"
        iswhere     += " AND dt_itemname LIKE '#{productname}'"
     end     
     isselect     = " tds.*,hd_type,hd_billnumber,hd_invoiceto,hd_dispmode,'' as dtweight"
     jons         = " JOIN trn_proforma_details tds ON(dt_compcode=hd_compcode AND hd_billnumber=dt_billnumber AND dt_sale_type=hd_sale_type)"
     isprodname   = TrnProformaHdr.select(isselect).joins(jons).where(iswhere).group('TRIM(dt_itemname)').order('TRIM(dt_itemname) ASC')
     arrp         = []
    if isprodname.length >0
          isprodname.each do |arp|
            compcode = arp.dt_compcode
            pdcode   = arp.dt_itemcode
            prdobj   = get_name_of_product(compcode,pdcode)
             if prdobj
                arp.dtweight  = prdobj.pd_weight
             end
            arrp.push arp
          end
           msg = "success"
           respond_to do |format|
            format.json { render :json => { 'data'=>arrp, "message"=>msg,:status=>true } }
           end
    end
end

private
def save_pack_listing
   comp_codes  =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
   comp_type   =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] : 'Local'
   @isCode     = 0
   @Startx     = '0000'
  if comp_codes!=nil || comp_codes!= ''
      @recCodes  = TrnPackingList.select("pl_number").where(["pl_compcode = ? AND  pl_sale_type=? AND pl_number >0 AND pl_local_type=?", comp_codes,params[:hd_sale_type],comp_type]).order('pl_number DESC').first
      if @recCodes
       @isCode    = @recCodes.pl_number.to_i
      end
   end
    @sumOfCode    = @isCode.to_i + 1
    if @sumOfCode.to_i < 10
      @sumOfCode = p @Startx.to_s + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 3
      @sumOfCode = p "000" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 4
      @sumOfCode = p "00" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length < 5
      @sumOfCode = p "0" + @sumOfCode.to_s
    elsif @sumOfCode.to_s.length >5
      @sumOfCode =  @sumOfCode.to_i
    end
    if params[:isprocessedupdated]!=nil && params[:isprocessedupdated]!='' && params[:isprocessedupdated]=='Y' && params[:pl_number].to_i >0
		     params[:pl_number] = params[:pl_number]
	   else
		     params[:pl_number] = @sumOfCode
	  end
   params[:pl_sale_type]        =  params[:hd_sale_type]!=nil && params[:hd_sale_type]!='' ? params[:hd_sale_type] : 'S'
   params[:pl_oa_number]        =  params[:pl_oa_number]!=nil && params[:pl_oa_number]!='' ? params[:pl_oa_number] : ''   
   params[:pl_totno_pices]      =  params[:pl_totno_pices]!=nil && params[:pl_totno_pices]!='' ? params[:pl_totno_pices] : 0
   params[:pl_totno_boxno]      =  params[:pl_totno_boxno]!=nil && params[:pl_totno_boxno]!='' ? params[:pl_totno_boxno] : 0
   params[:pl_tot_netweight]    =  params[:pl_tot_netweight]!=nil && params[:pl_tot_netweight]!='' ? params[:pl_tot_netweight] : 0
   params[:pl_apprx_value]      =  params[:pl_apprx_value]!=nil && params[:pl_apprx_value]!='' ? params[:pl_apprx_value] : 0
   params[:pl_tot_grossweight]  =  params[:pl_tot_grossweight]!=nil && params[:pl_tot_grossweight]!='' ? params[:pl_tot_grossweight] : 0
   params[:pl_tot_perkg]        =  params[:pl_tot_perkg]!=nil && params[:pl_tot_perkg]!='' ? params[:pl_tot_perkg] : 0
  dt = 0
  if  params[:pl_date]!=nil  && params[:pl_date]!=''
      ndt = Date.parse(params[:pl_date].to_s)
      dt  = ndt.strftime("%Y-%m-%d")
  end
   params[:pl_compcode]   = comp_codes
   params[:pl_local_type] = comp_type
   params[:pl_date]       = dt   
     params.permit(:pl_compcode,:pl_number,:pl_date,:pl_sale_type,:pl_local_type,:pl_oa_number,:pl_totno_pices,:pl_totno_boxno,:pl_tot_netweight,:pl_tot_grossweight,:pl_apprx_value,:pl_tot_perkg)
end

private
def process_grid_data(pld_number)
   comp_codes      =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
   comp_type       =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] : 'Local'
   pld_sale_type   =  params[:hd_sale_type]!=nil && params[:hd_sale_type]!='' ? params[:hd_sale_type] : 'S'
   pld_oa_number   =  params[:pl_oa_number]!=nil && params[:pl_oa_number]!='' ? params[:pl_oa_number] : ''
  if params[:dt_itemcode]!='' && params[:dt_itemcode]!=nil
      i = 0
      params[:dt_itemcode].each do |tnd|
            if params[:dt_itemcode][i]!=nil && params[:dt_itemcode][i]!=''
               pld_itemcode = params[:dt_itemcode][i]
            else
               pld_itemcode = ''
            end
            if params[:dt_itemname][i]!=nil && params[:dt_itemname][i]!=''
               pld_itemname = params[:dt_itemname][i]
            else
               pld_itemname = ''
            end
            if params[:dt_quantity][i]!=nil && params[:dt_quantity][i]!=''
               pld_qty = params[:dt_quantity][i]
            else
               pld_qty = 0
            end
            if params[:bill_id][i]!=nil && params[:bill_id][i]!=''
               bill_id = params[:bill_id][i]
            else
               bill_id = 0
            end
            if params[:dt_material][i]!=nil && params[:dt_material][i]!=''
               pld_material = params[:dt_material][i]
            else
               pld_material = ''
            end
            if params[:dt_color][i]!=nil && params[:dt_color][i]!=''
               pld_color = params[:dt_color][i]
            else
               pld_color = ''
            end
            if params[:dt_boxno][i]!=nil && params[:dt_boxno][i]!=''
               pld_box_no = params[:dt_boxno][i]
            else
               pld_box_no = 0
            end
            if params[:dt_qty_hdr][i]!=nil && params[:dt_qty_hdr][i]!=''
               pld_outer_qty = params[:dt_qty_hdr][i]
            else
               pld_outer_qty = 0
            end
            if params[:dt_weight][i]!=nil && params[:dt_weight][i]!=''
               pld_weight = params[:dt_weight][i]
            else
               pld_weight = 0
            end
            if params[:dt_net_weight][i]!=nil && params[:dt_net_weight][i]!=''
               pld_net_weight = params[:dt_net_weight][i]
            else
               pld_net_weight = 0
            end
            if params[:dt_packing_weight][i]!=nil && params[:dt_packing_weight][i]!=''
               pld_pck_weight = params[:dt_packing_weight][i]
            else
               pld_pck_weight = 0
            end
            if params[:dt_gross_weight][i]!=nil && params[:dt_gross_weight][i]!=''
               pld_gross_weight = params[:dt_gross_weight][i]
            else
               pld_gross_weight = 0
            end
            if params[:dt_values][i]!=nil && params[:dt_values][i]!=''
               pld_netvalues = params[:dt_values][i]
            else
               pld_netvalues = 0
            end
              if pld_qty.to_i >0
                 create_packlist_linking(comp_codes,comp_type,pld_itemcode,pld_itemname,pld_number,pld_sale_type,pld_oa_number,pld_material,pld_color,pld_qty,pld_outer_qty,pld_box_no,pld_weight,pld_net_weight,pld_pck_weight,pld_gross_weight,pld_netvalues,bill_id)
              end
          i += 1
      end
   end
end

private
def create_packlist_linking(comp_codes,comp_type,pld_itemcode,pld_itemname,pld_number,pld_sale_type,pld_oa_number,pld_material,pld_color,pld_qty,pld_outer_qty,pld_box_no,pld_weight,pld_net_weight,pld_pck_weight,pld_gross_weight,pld_netvalues,bill_id)
    isobjupdate = TrnPackingListDetail.where("pld_compcode=? AND id= ? ",comp_codes,bill_id).first
    if isobjupdate
         isobjupdate.update(:pld_compcode=>comp_codes,:pld_locality_type=>comp_type,:pld_itemcode=>pld_itemcode,:pld_itemname=>pld_itemname,:pld_number=>pld_number,:pld_sale_type=>pld_sale_type,:pld_oa_number=>pld_oa_number,:pld_material=>pld_material,:pld_color=>pld_color,:pld_qty=>pld_qty,:pld_outer_qty=>pld_outer_qty,:pld_box_no=>pld_box_no,:pld_weight=>pld_weight,:pld_net_weight=>pld_net_weight,:pld_pck_weight=>pld_pck_weight,:pld_gross_weight=>pld_gross_weight,:pld_netvalues=>pld_netvalues)
         ## execute message if required
    else
          nobsave =   TrnPackingListDetail.new(:pld_compcode=>comp_codes,:pld_locality_type=>comp_type,:pld_itemcode=>pld_itemcode,:pld_itemname=>pld_itemname,:pld_number=>pld_number,:pld_sale_type=>pld_sale_type,:pld_oa_number=>pld_oa_number,:pld_material=>pld_material,:pld_color=>pld_color,:pld_qty=>pld_qty,:pld_outer_qty=>pld_outer_qty,:pld_box_no=>pld_box_no,:pld_weight=>pld_weight,:pld_net_weight=>pld_net_weight,:pld_pck_weight=>pld_pck_weight,:pld_gross_weight=>pld_gross_weight,:pld_netvalues=>pld_netvalues)
          if nobsave.save
            ## execute message if required
          end
    end
end

private
def rollback_billing_if_not_acl(billnumber)
      ompcodes    =  params[:hd_company]!=nil && params[:hd_company]!='' ? params[:hd_company] : @compcodes
      hdtype      =  params[:hd_type]!=nil && params[:hd_type]!='' ? params[:hd_type] : ''
      @chkObj     =  TrnPackingList.joins('INNER JOIN trn_packing_list_details trn ON(pld_compcode=pl_compcode AND pld_sale_type=pl_sale_type AND pld_number=pl_number AND pld_locality_type=pl_local_type)').where("pl_compcode = ? AND pl_number=? AND pl_sale_type= ? AND pl_local_type=?",ompcodes,billnumber,params[:hd_sale_type],hdtype)
      if @chkObj.length <= 0
          @delObj =  TrnPackingList.where("pl_compcode = ? AND pl_number=? AND pl_sale_type= ? AND pl_local_type=?",ompcodes,billnumber,params[:hd_sale_type],hdtype).first
          if @delObj
            @delObj.destroy
          end
      end

end

end ## END CLASS
