class TaskPanelController < ApplicationController
  before_action :require_login
  before_action :allowed_pages
  before_action :is_allowed_location
  skip_before_action :verify_authenticity_token,:only=> [:index,:ajax_process,:search,:view_task]
  include ErpModule::Common
  helper_method :get_rake_tpe,:get_site_names,:currency_formatted,:formatted_date,:year_month_days_formatted,:get_assign_batch_attached
  helper_method :get_user_chat_data,:get_user_category_data
def index
     @compcodes    = session[:loggedUserCompCode]
     @batchtask    = MstBatchTaskList.where("bt_compcode = ? ",@compcodes).order("bt_name ASC")
     @batchCateg   = MstBatchTaskCategory.where("btc_compcode = ? ",@compcodes).order("btc_name ASC")
     @mstXEmpEdit  = User.where("usercompcode = ?",@compcodes).order("firstname ASC")
     @AllSNo       = MstSiteMaster.select("st_number,id,st_name").where(["st_compcode = ? AND st_number >0", @compcodes]).order('st_name ASC')
     @lastnumber   = get_last_bill_dt
     @viewtask     = nil
     @assleadby    = nil
     @cdates       = Time.now.to_date
     if params[:id].to_i >0
       @viewtask = TrnBatchTaskAssign.where("bts_compcode = ? AND id = ?",@compcodes,params[:id]).first
       assignby  = @viewtask.bts_assignby
       @assleadby = User.where("usercompcode = ? and id= ?",@compcodes,assignby).first
     end

end

def view_task
   @compcodes    = session[:loggedUserCompCode]
   @mstXEmpEdit  = User.where("usercompcode = ?",@compcodes).order("firstname ASC")
   @AllSNo       = MstSiteMaster.select("st_number,id,st_name").where(["st_compcode = ? AND st_number >0", @compcodes]).order('st_name ASC')
   if params[:page].to_i >0
    pages = params[:page]
  else
     pages = 1
  end
  iswhere = "bts_compcode='#{@compcodes}' AND bts_type = 'M'"
  if params[:from_date]!=nil && params[:from_date]!= ''
      frmdated = year_month_days_formatted(params[:from_date])
      iswhere   += " AND bts_assigndate >='#{frmdated}'"
      @from_date = params[:from_date]
  end
   if params[:upto_date]!=nil && params[:upto_date]!= ''
      uptodated = year_month_days_formatted(params[:upto_date])
      iswhere   += " AND bts_assigndate <='#{uptodated}'"
      @upto_date = params[:upto_date]
  end
  if params[:sitename] !=nil && params[:sitename] != ''
      siteno    = params[:sitename]
      iswhere   += " AND bts_siteno ='#{siteno}'"
      @sitename = siteno
  end
   if params[:assignto] !=nil && params[:assignto] != ''
        assignto  = params[:assignto]
        iswhere   += " AND bts_assignto ='#{assignto}'"
        @assignto = assignto
  end
   @assigntask  =  TrnBatchTaskAssign.where(iswhere).paginate(:page =>pages,:per_page => 10).order("bts_assigndate DESC")
end

def ajax_process
   @compcodes  = session[:loggedUserCompCode]
  if params[:indentity] !=nil && params[:indentity] !='' && params[:indentity] =='ADDTASK'
      process_save_batchtask_by_jquery();
      return
  elsif params[:indentity] !=nil && params[:indentity] !='' && params[:indentity] =='UPDTASK'
      set_update_from_assigner();
      return
  elsif params[:indentity] !=nil && params[:indentity] !='' && params[:indentity] =='CONVSTS'
      task_conversation_posting_data();
      return
  elsif params[:indentity] !=nil && params[:indentity] !='' && params[:indentity] =='CHTSESSDATA'
      load_chat_posting_data();      
      return
   elsif params[:indentity] !=nil  && params[:indentity] !='' && params[:indentity] == 'ADDCHKLIST'
       process_add_check_list()
       return
  elsif params[:indentity] !=nil  && params[:indentity] !='' && params[:indentity] == 'DELTCHKLIST'
       delete_user_check_list()
       return
  elsif params[:indentity] !=nil  && params[:indentity] !='' && params[:indentity] == 'GTSTWS'
       get_catgory_list()
       return
  elsif params[:indentity] !=nil  && params[:indentity] !='' && params[:indentity] == 'TSKVIEW'
       set_review_task()
       return
  elsif params[:indentity] !=nil  && params[:indentity] !='' && params[:indentity] == 'CHATVIEW'
       set_chat_review_task()
       return
  elsif params[:indentity] !=nil  && params[:indentity] !='' && params[:indentity] == 'NTFVIEW'
       set_update_chat_message()
       return
   elsif params[:indentity] !=nil  && params[:indentity] !='' && params[:indentity] == 'AUTVW'
       update_chat_review_task()
       return
  end

  
end

def create
  @compcodes  = session[:loggedUserCompCode]
  isFlags       = true
   begin
      if params[:bts_assigndate]==nil || params[:bts_assigndate]==''
            flash[:error] = "Please enter start date."
            isFlags       = false      
      elsif params[:bts_description] == nil || params[:bts_description] ==''
            flash[:error] = "Please select batch task."
            isFlags       = false
       elsif params[:bts_siteno]==nil || params[:bts_siteno]==''
            flash[:error] = "Please enter site name."
            isFlags       = false
      elsif params[:assigntask] == nil || params[:assigntask] ==''
            flash[:error] = "Please select assign to."
            isFlags       = false
      else
             
             taskid   =  params[:bts_tasknumber]!=nil && params[:bts_tasknumber]!='' ?  params[:bts_tasknumber] : 0
             mid       = params[:mid]
             if mid.to_i >0
                   updaterake  =  TrnBatchTaskAssign.where("bts_compcode=? AND id = ?",@compcodes,mid).first
                   if updaterake
                       updaterake.update(save_rake)
                        new_attach_all_files(params[:bts_tasknumber])
                       deletes_all_files()
                       flash[:error] = "Data Updated Successfully."
                       isFlags       = true
                   
                   end
            
             else
                     
                   if isFlags
                      saveobj =  TrnBatchTaskAssign.new(save_rake)
                      if saveobj.save
                         conratcnumber = @sumXOfCode
                         new_attach_all_files(conratcnumber)
                         mynewtaskassgnd = ''
                          if params[:myassigntask] !=nil && params[:myassigntask] !=''
                            mynewtaskassgnd = params[:myassigntask].to_s.split(",")
                          else
                             mynewtaskassgnd = params[:assigntask]
                          end
                         send_notification_new_task(@compcodes,params[:bts_taskcat],params[:bts_siteno],mynewtaskassgnd,params[:bts_assigndate])
                         flash[:error] = "Data Saved Successfully."
                         isFlags       = true
                      end
                   end
             end
       end
    rescue Exception => exc
        flash[:error]            =   "#{exc.message}"
        session[:isErrorhandled] = 1
        isFlags                  = false
     end
    if !isFlags
      session[:isErrorhandled] = 1
    else
      session[:isErrorhandled] = nil
    end
    redirect_to "#{root_url}task_panel"
end
def destroy
 customerid     =  params[:id].to_i
 @compcodes     =  session[:loggedUserCompCode] 
 @RakeObj       =  TrnBatchTaskAssign.where("bts_compcode =? AND id=? ",@compcodes,customerid).first
 if @RakeObj
    tasknumber  = @RakeObj.bts_tasknumber   
     selobj = TrnAssignTaskAttach.where("ata_compcode =? AND ata_taskid =?",@compcodes,tasknumber)
     if selobj.length >0
         selobj.each do |netask|
            remove_processs_files(compcodes,netask.id)
         end
     end
      @RakeObj.destroy
        flash[:error] =  "Data deleted successfully."
        session[:isErrorhandled] = nil
    
  end
  redirect_to "#{root_url}"+"task_panel/view_task"
end
def task_panel_refresh
 session[:request_params] = nil
 session.delete(:request_params)
 redirect_to "#{root_url}"+"task_panel"
end

private
def save_rake
  params[:bts_compcode] = @compcodes
  @isCode    = 0
  @Startx    = '0000'
  @recCodes  = TrnBatchTaskAssign.select("bts_tasknumber").where(["bts_compcode = ? AND bts_tasknumber >0", @compcodes]).order('bts_tasknumber DESC').first
   if @recCodes
    @isCode    = @recCodes.bts_tasknumber.to_i
   end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_s.length < 2
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >=5
      @sumXOfCode =  @sumXOfCode.to_i
    end
    if params[:isprocessedupdated]!=nil && params[:isprocessedupdated]!='' && params[:isprocessedupdated] == 'Y'
       params[:bts_tasknumber]   = params[:bts_tasknumber]
    else
       params[:bts_tasknumber]   = @sumXOfCode
   end
   ##### PROCESS MULTI ASSIGN TASK USER #####
    k = 1
    assigntask = ''
    if params[:myassigntask] !=nil && params[:myassigntask] !=''
      mynewtaskassgnd = params[:myassigntask].to_s.split(",")
    else
       mynewtaskassgnd = params[:assigntask]
    end
   if mynewtaskassgnd !=nil  && mynewtaskassgnd != ''
         mynewtaskassgnd.each do |newtask|
                if newtask != nil && newtask != ''
                   assigntask += newtask.to_s+","
                end
                k +=1
          end
          if assigntask !=nil && assigntask!=''
            assigntask = assigntask.to_s.chop
          end
    end

  #### END MULTI ASSIGN USER #########
  params[:bts_assignby]        = session[:autherizedUserId]
  params[:bts_batchtask]       =  0  
  params[:bts_nodays]          =  0
  params[:bts_description]     =  params[:bts_description]!=nil && params[:bts_description]!='' ? params[:bts_description].strip : ''  
  params[:bts_assignto]        =  0
  params[:bts_siteno]          =  params[:bts_siteno]!=nil && params[:bts_siteno]!='' ? params[:bts_siteno].to_s.strip : ''
  params[:bts_type]            =  'M'
  params[:bts_priority]        =  params[:bts_priority]!=nil && params[:bts_priority]!='' ? params[:bts_priority].to_s.strip : ''
  params[:bts_confirm]         =  params[:bts_confirm]!=nil && params[:bts_confirm]!='' ? params[:bts_confirm].to_s.strip : ''  
  params[:bts_taskcat]         =  params[:bts_taskcat]!=nil && params[:bts_taskcat]!='' ? params[:bts_taskcat].to_s.strip : 0
  params[:bts_multiassign]     =  assigntask
  params[:bts_assignednotify]  =  assigntask

  dt        = 0
  targdate  = 0
  if params[:bts_assigndate]!=nil && params[:bts_assigndate]!=''
    dt = year_month_days_formatted(params[:bts_assigndate])
  end
  if params[:bts_tragetdate]!=nil && params[:bts_tragetdate]!=''
    targdate = year_month_days_formatted(params[:bts_tragetdate])
  end
  params[:bts_assigndate]      =  dt
  params[:bts_tragetdate]      =  targdate
  params.permit(:bts_compcode,:bts_assignednotify,:bts_multiassign,:bts_assignby,:batch_category,:bts_tasknumber,:bts_tragetdate,:bts_batchtask,:bts_taskcat,:bts_nodays,:bts_description,:bts_assigndate,:bts_assignto,:bts_siteno,:bts_type,:bts_priority,:bts_confirm)

end


private
def get_last_bill_dt
  @xLoc       = (session[:autherizedLoc].to_i >0) ? session[:autherizedLoc] : 0
  @isCode     = 0
  @Startx    = '0000'
  @recCodes  = TrnBatchTaskAssign.select("bts_tasknumber").where(["bts_compcode = ? AND bts_tasknumber >0", @compcodes]).order('bts_tasknumber DESC').first
   if @recCodes
    @isCode    = @recCodes.bts_tasknumber.to_i
   end
    @sumXOfCode    = @isCode.to_i + 1
    if @sumXOfCode.to_s.length < 2
      @sumXOfCode = p @Startx.to_s + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 3
      @sumXOfCode = p "000" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 4
      @sumXOfCode = p "00" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length < 5
      @sumXOfCode = p "0" + @sumXOfCode.to_s
    elsif @sumXOfCode.to_s.length >=5
      @sumXOfCode =  @sumXOfCode.to_i
    end
    return @sumXOfCode
end
private
def process_enquiry_files(compcodes,files,docid,fileid,cfl_title)
      if  fileid!=nil && fileid!='' && files!=nil && files!=''
       
             selobj = TrnAssignTaskAttach.where("ata_compcode =? AND id=?",compcodes,docid).first
              if selobj
                  selobj.update(:ata_attach=>files,:ata_title=>cfl_title)
              else
                
                  objenq = TrnAssignTaskAttach.new(:ata_compcode=>compcodes,:ata_taskid=>fileid,:ata_attach=>files,:ata_title=>cfl_title)
                  if objenq.save
                    ## execute message
                  end
              end
      end
end


private
def new_attach_all_files(fileid)

     if params[:processedit]!=nil && params[:processedit]!=''
         i = 0
         k = 1

            params[:processedit].each do |fil|
                if  params["myreceivedocumentid#{i}"].to_i >0
                       recvdocuments = params["myreceivedocumentid#{i}"]
                       cftitle       = params["cfl_title#{i}"]
                       currentfile   = params["existfile#{i}"]
                       nremove       = params["removefiles#{i}"]
                       if params["receivefile#{i}"]!=nil && params["receivefile#{i}"]!=''
                             filename      =  params["receivefile#{i}"]
                             filex         =  new_attach_files(filename,k)
                             process_enquiry_files(@compcodes,filex,recvdocuments,fileid,cftitle)
                       else
                            if currentfile!=nil && currentfile!=''
                                filex         = currentfile
                                if nremove.to_i <=0
                                  process_enquiry_files(@compcodes,filex,recvdocuments,fileid,cftitle)
                                end
                            end
                       end
                end

                 i +=1
                 k +=1
           end
     end
     if params[:receivefile]!=nil && params[:receivefile]!=''
           m = 0
           c = 1
            params[:receivefile].each do |fil|
                if  params[:myreceivedocumentid][m].to_i <=0
                 
                      recvdocuments = params[:myreceivedocumentid][m]
                      cftitle       = params[:cfl_title][m]
                       if params[:receivefile][m]!=nil && params[:receivefile][m]!=''
                             filename      =  params[:receivefile][m]
                             filex         =  new_attach_files(filename,c)
                             process_enquiry_files(@compcodes,filex,recvdocuments,fileid,cftitle)
                       end
                end
                 m +=1
                 c +=1
           end
     end

end

private
def deletes_all_files
   compcodes    = session[:loggedUserCompCode]
  i =0
  if params[:processedit]!=nil && params[:processedit]!=''
       params[:processedit].each do |fls|
          if  params["removefiles#{i}"]!=nil &&  params["removefiles#{i}"]!=''
            remove_processs_files(compcodes,params["removefiles#{i}"])
          end
          i +=1
       end
  end
end

private
def remove_processs_files(compcodes,docid)
  selobj = TrnAssignTaskAttach.where("ata_compcode =? AND id=?",compcodes,docid).first
  if selobj
    filname      = selobj.ata_attach
    path_to_file = Rails.root.join "public", "images","taskpanel",filname
    unlinks_the_files(path_to_file)
    selobj.destroy
  end
end

private
  def unlinks_the_files(path_to_file)
    File.delete(path_to_file) if File.exist?(path_to_file)
  end

private
  def new_attach_files(files,cnt)
    file_name     =  files.original_filename  if  ( files !='')
    file          =  files.read
    file_type     =  file_name.split('.').last
    new_name_file = Time.now.to_i+cnt.to_i
    new_file_name = "#{new_name_file}." + file_type
    @Imgs         = new_file_name
    @paths        = Rails.root.join "public", "images", "taskpanel"
    ######### Upload here ######################
    File.open("#{@paths}/" +new_file_name, "wb")  do |f|
      f.write(file)
    end
    return new_file_name
  end
  
  private
  def process_save_batchtask_by_jquery
    @compcodes  = session[:loggedUserCompCode]
    isFlags      = true
    message      = ''
   begin
      if params[:bts_assigndate]==nil || params[:bts_assigndate]==''
            message    = "Please enter start date."
            isFlags       = false
      elsif params[:bts_description] == nil || params[:bts_description] ==''
            message       = "Please select batch task."
            isFlags       = false
       elsif params[:bts_siteno]==nil || params[:bts_siteno]==''
            message       = "Please enter site name."
            isFlags       = false
      elsif params[:bts_assignto] == nil || params[:bts_assignto] ==''
            message       = "Please select assign to."
            isFlags       = false
      else

             
             mid       = params[:mid]
             taskname  = params[:bts_description].to_s.strip.delete(' ').downcase
             if mid.to_i >0
                   updaterake  =  TrnBatchTaskAssign.where("bts_compcode=? AND id = ?",@compcodes,mid).first
                   if updaterake
                       updaterake.update(save_rake)
                        new_attach_all_files(params[:bts_tasknumber])
                       deletes_all_files()
                         send_notification_new_task(@compcodes,params[:bts_taskcat],params[:bts_siteno],params[:multiassign],params[:bts_assigndate])
                       message = "Data Updated Successfully."
                       isFlags = true

                   end

             else
                  stobs =  TrnBatchTaskAssign.where("LOWER(REPLACE(bts_description,' ','')) = ?",taskname)
                  if stobs.length>0
                     isFlags = false;
                     message = "This task already created."
                  end
                   if isFlags
                      saveobj =  TrnBatchTaskAssign.new(save_rake)
                      if saveobj.save
                         conratcnumber = @sumXOfCode
                         new_attach_all_files(conratcnumber)
                         send_notification_new_task(@compcodes,params[:bts_taskcat],params[:bts_siteno],params[:multiassign],params[:bts_assigndate])
                         message = "Data Saved Successfully."
                         isFlags = true
                      end
                   end
             end
       end
    rescue Exception => exc
        message            =   "#{exc.message}"
        session[:isErrorhandled] = 1
        isFlags                  = false
     end
    if !isFlags
      session[:isErrorhandled] = 1
    else
      session[:isErrorhandled] = nil
    end
    respond_to do |format|
      format.json { render :json => { 'data'=>'',:status=>isFlags,"message"=>message } }
    end
end

  private
  def set_update_from_assigner
    taskid     = params[:taskid]
    priority   = params[:priority]
    taskstatus = params[:taskstatus]
    message    = ''
    status     = false
    taskobj    = TrnBatchTaskAssign.where("bts_compcode = ? AND id = ?",@compcodes,taskid).first
    if taskobj
        if priority !=nil && priority !=''
           prioritys = priority
        else
           prioritys = taskobj.bts_priority
        end
        if taskstatus !=nil && taskstatus !=''
          taskstatuss = taskstatus
        else
          taskstatuss = taskobj.bts_readstatus
        end
        taskobj.update(:bts_priority=>prioritys,:bts_readstatus=>taskstatuss)
        status  = true
        message = "Data updated sucessfully."
    end
    respond_to do |format|
      format.json { render :json => { 'data'=>'',:status=>status,"message"=>message } }
    end

  end
  
  private
  def task_conversation_posting_data
      taskid         = params[:taskid]
      consationto    = params[:consationto]  ### receiver TO
      senderid       = params[:consationfrom] ## sender
      messsagepost   = params[:messsagepost]
      status         = false
      message        = ""
      triglength     = 0
       if taskid.to_i <=0
           ### EXECUTE message
       elsif consationto.to_i <=0
           ### EXECUTE message
        elsif messsagepost == nil || messsagepost == ''
       ### EXECUTE message
       else
           convsobj =  TrnConversastionDetail.new(params_consation)
           if convsobj.save
              status  = true
           end
       end
        isselect      =  "trn_conversastion_details.*,'' as conversationtopersion,'' as fromimage,'' as toimages"
        isselect      += ",'' as conversationfrmpersion,'' as sendername,'' as receivername,cd_fileattachement,'' as attachurl"
        isselect      += ",DATE_FORMAT(created_at,'%M %d, %Y') as posteddated,cd_time as postedtime"
        arrconv       = []
        iswhere       =  " cd_compcode ='#{@compcodes}' AND cd_taskid='#{taskid}'"
        iswhere       += " AND ((cd_receiver_id IN('#{consationto}') AND cd_sender_id IN('#{senderid}') ) OR (cd_receiver_id IN('#{senderid}') AND cd_sender_id IN('#{consationto}') ))"
        conslisted = TrnConversastionDetail.select(isselect).where(iswhere).order("created_at ASC")
        if conslisted.length >0
            triglength = conslisted.length
            conslisted.each do |newconv|
                          if newconv.cd_fileattachement !=nil && newconv.cd_fileattachement != ''
                             imgpath    = "#{Rails.root}/public/images/chatfile/"+newconv.cd_fileattachement.to_s
                             filetype   = newconv.cd_fileattachement.to_s.split(".")
                             if File.file?(imgpath)
                                 if filetype[1] == 'jpg' || filetype[1] == 'jpeg' || filetype[1] == 'png' || filetype[1] == 'gif'
                                   filepath = '<a href="'+root_url.to_s+'images/chatfile/'+newconv.cd_fileattachement.to_s+'" target="_blank"><img width="20%" src="'+root_url.to_s+'images/chatfile/'+newconv.cd_fileattachement.to_s+'"/></a>'
                                 else
                                   filepath = '<a href="'+root_url.to_s+'images/chatfile/'+newconv.cd_fileattachement.to_s+'" target="_blank">'+newconv.cd_fileattachement.to_s+'</a>'
                                end
                                newconv.attachurl = filepath
                             end
                           end
                           senderobj    =  get_user_chat_data(newconv.cd_sender_id)
                           receiverobj  =  get_user_chat_data(newconv.cd_receiver_id)
                           ########## SENDER PROFILE
                           if senderobj
                              newconv.sendername = senderobj.firstname
                               if senderobj.userimage !=nil  && senderobj.userimage != ''
                                    pathsecond   = Rails.root.join "public", "images", "users",senderobj.userimage.to_s
                                    if File.exist?(pathsecond)
                                       newconv.fromimage = root_url.to_s+"images/users/"+senderobj.userimage.to_s
                                    else
                                      newconv.fromimage = root_url.to_s+"images/users-icons.png"
                                    end
                               else
                                    newconv.fromimage = root_url.to_s+"images/users-icons.png"
                               end
                           end
                            ########## END SENDER PROFILE
                            if receiverobj
                               newconv.receivername = receiverobj.firstname
                               if receiverobj.userimage !=nil  && receiverobj.userimage != ''
                                     pathfirst    = Rails.root.join "public", "images", "users",receiverobj.userimage.to_s
                                     if File.exist?(pathfirst)
                                        newconv.toimages = root_url.to_s+"images/users/"+receiverobj.userimage.to_s
                                     else
                                       newconv.toimages = root_url.to_s+"images/users-icons.png"
                                     end
                                else
                                       newconv.toimages = root_url.to_s+"images/users-icons.png"
                                end
                            end
                            

                    arrconv.push newconv
              end
               status  = true
        end
        respond_to do |format|
          format.json { render :json => { 'data'=>arrconv,:status=>status,"message"=>message,'trigcount'=>triglength  } }
        end
  end
  
  private
  def params_consation
      params[:cd_taskid]      = params[:taskid]
      params[:cd_sender_id]   = params[:consationfrom]
      params[:cd_receiver_id] = params[:consationto]
      params[:cd_conmessage]  = params[:messsagepost]
      params[:cd_compcode]    = @compcodes
      params[:cd_messageby]   = session[:autherizedUserId]
      if params[:attachedfile] != nil && params[:attachedfile] != ''
        params[:cd_fileattachement] = process_chat_files()
      else
        params[:cd_fileattachement] = ''
      end
      params[:cd_readstatus]     = params[:consationto].to_s+","+params[:cd_sender_id].to_s
      Time.zone = "Kolkata"
      billtimes = Time.zone.now.strftime('%I:%M%p')
      params[:cd_time] = billtimes
      params.permit(:cd_compcode,:cd_readstatus,:cd_fileattachement,:cd_messageby,:cd_taskid,:cd_sender_id,:cd_receiver_id,:cd_conmessage,:cd_time)
  end
  private
  def process_chat_files
    file_name     =  params[:attachedfile].original_filename  if  ( params[:attachedfile] !='')
    file          =  params[:attachedfile].read
    file_type     =  file_name.split('.').last
    new_name_file =  Time.now.to_i
    new_file_type =  "#{new_name_file}." + file_type
    @chatImgs     =  new_file_type
    adharpath     =  Rails.root.join "public", "images", "chatfile"
    #### DELETE ORIGIN #############
    if params[:attachedfile]!= '' && params[:attachedfile]!= nil
       if params[:currentadharfile]!= '' && params[:currentadharfile]!= nil
          unlinkpath    = Rails.root.join "public", "images", "chatfile",params[:currentadharfile].to_s
          unlinks_the_files(unlinkpath)
       end
    end
    ######### Upload here ######################
    File.open("#{adharpath}/" + new_file_type, "wb")  do |f|
      f.write(file)
    end
    return new_file_type
  end
  
  private
  def load_chat_posting_data
      taskid         = params[:taskid]
      consationto    = params[:consationto]
      senderid       = params[:consationfrom]      
      status         = false
      message        = ""
      triglength     = 0
      loggeduser     = session[:autherizedUserId]
        isselect      =  "trn_conversastion_details.*,'' as conversationtopersion,'' as fromimage,'' as toimages"
        isselect      += ",'' as conversationfrmpersion,'' as sendername,'' as receivername,cd_fileattachement,'' as attachurl"
        isselect      += ",DATE_FORMAT(created_at,'%M %d, %Y') as posteddated,cd_time as postedtime"
        arrconv       = []
        iswhere       =  " cd_compcode ='#{@compcodes}' AND cd_taskid='#{taskid}'"
        iswhere       += " AND (  FIND_IN_SET('#{loggeduser}',cd_receiver_id)>0  OR FIND_IN_SET('#{loggeduser}',cd_sender_id)>0 ) "
        conslisted = TrnConversastionDetail.select(isselect).where(iswhere).order("created_at ASC")
        if conslisted.length >0
            triglength = conslisted.length
            conslisted.each do |newconv|                          
                           
                           if newconv.cd_fileattachement !=nil && newconv.cd_fileattachement != ''
                             imgpath    = "#{Rails.root}/public/images/chatfile/"+newconv.cd_fileattachement.to_s
                             filetype   = newconv.cd_fileattachement.to_s.split(".")
                             if File.file?(imgpath)
                                 if filetype[1] == 'jpg' || filetype[1] == 'jpeg' || filetype[1] == 'png' || filetype[1] == 'gif'
                                   filepath = '<a href="'+root_url.to_s+'images/chatfile/'+newconv.cd_fileattachement.to_s+'" target="_blank"><img width="20%" src="'+root_url.to_s+'images/chatfile/'+newconv.cd_fileattachement.to_s+'"/></a>'
                                 else
                                   filepath = '<a href="'+root_url.to_s+'images/chatfile/'+newconv.cd_fileattachement.to_s+'" target="_blank">'+newconv.cd_fileattachement.to_s+'</a>'
                                end
                                newconv.attachurl = filepath
                             end
                           end
                           ########## SENDER PROFILE
                           senderobj    =  get_user_chat_data(newconv.cd_messageby)
                           if senderobj
                              newconv.sendername = senderobj.firstname
                               if senderobj.userimage !=nil  && senderobj.userimage != ''
                                    pathsecond   = Rails.root.join "public", "images", "users",senderobj.userimage.to_s
                                    if File.exist?(pathsecond)
                                       newconv.fromimage = root_url.to_s+"images/users/"+senderobj.userimage.to_s
                                    else
                                      newconv.fromimage = root_url.to_s+"images/users-icons.png"
                                    end
                               else
                                    newconv.fromimage = root_url.to_s+"images/users-icons.png"
                               end
                           end
                            


                    arrconv.push newconv
              end
              status =true
        end
       
        respond_to do |format|
          format.json { render :json => { 'data'=>arrconv,:status=>status,"message"=>message,'trigcount'=>triglength } }
        end
  end

  private
def process_add_check_list
  userid       = session[:logedUserId]
  notereamrks  = params[:notereamrks]!=nil && params[:notereamrks]!='' ? params[:notereamrks] : ''
  messageid    = params[:messageid].to_i >0 ? params[:messageid] : 0
  istatus      = false
  iswhere      = "ucl_compcode ='#{@compcodes}' AND ucl_userid ='#{userid}' AND ucl_messageid ='#{messageid}'"
  chlstobj     = TrnUserCheckList.where(iswhere).first
 if chlstobj
      chlstobj.update(:ucl_remark=>notereamrks)
      istatus = true
 else
      svchkobj = TrnUserCheckList.new(:ucl_compcode=>@compcodes,:ucl_userid=>userid,:ucl_messageid=>messageid,:ucl_remark=>notereamrks)
      if svchkobj.save
          istatus =true
      end
  end

 respond_to do |format|
  format.json { render :json => { :status=>istatus,'data'=>'' } }
 end
end

private
def delete_user_check_list
  userid       = session[:logedUserId]  
  messageid    = params[:messageid].to_i >0 ? params[:messageid] : 0
  istatus      = false
  iswhere      = "ucl_compcode ='#{@compcodes}' AND ucl_userid ='#{userid}' AND ucl_messageid ='#{messageid}'"
  chlstobj     = TrnUserCheckList.where(iswhere).first
 if chlstobj
      chlstobj.destroy
      istatus = true 
  end
 respond_to do |format|
  format.json { render :json => { :status=>istatus,'data'=>'' } }
 end

end

private
def get_catgory_list  
  siteno       = params[:siteno].to_i >0 ? params[:siteno] : 0
  istatus      = false
  sitecats     = ""
  mstsiteobj   = MstSiteMaster.select("st_category").where(["st_compcode = ? AND st_number=?", @compcodes,siteno]).first
  if mstsiteobj !=nil
        sitecats     = mstsiteobj.st_category
        if sitecats !=nil && sitecats != ''
            iswhere      = "btc_compcode ='#{@compcodes}' AND  id IN(#{sitecats})"
            chlstobj     = MstBatchTaskCategory.where(iswhere).order("btc_name ASC")
             if chlstobj.length >0
                  istatus = true
              end
        end
  end
   respond_to do |format|
    format.json { render :json => { :status=>istatus,'data'=>chlstobj } }
   end

end

private
def set_review_task
  loguserid   =  session[:autherizedUserId]
  taskid      =  params[:taskid]
  istatus     = false
  updaterake  =  TrnBatchTaskAssign.where("bts_compcode = ? AND id = ?",@compcodes,taskid).first
  if updaterake
       rvtask = updaterake.bts_assignednotify
       tskp   = ""
       if rvtask
             newtsk = rvtask.to_s.split(",")
             if newtsk.length >0
                   newtsk.each do |newks|
                       if loguserid.to_i != newks.to_i
                           tskp +=newks.to_s+","
                       end
                   end
                   if tskp
                     tskp = tskp.to_s.chop
                   end
             end
       end
      updaterake.update(:bts_assignednotify=>tskp)
      istatus = true
  end
  
  iswhere  = "bts_compcode ='#{@compcodes}' AND FIND_IN_SET('#{loguserid}',bts_assignednotify)>0"
  dataobj  = TrnBatchTaskAssign.where(iswhere).group("bts_description").order("bts_description")
  respond_to do |format|
    format.json { render :json => { :status=>istatus,'data'=>dataobj } }
  end
  
end



private
def set_chat_review_task
    loguserid     =  session[:autherizedUserId]
    taskid        =  params[:taskid]
    istatus       =  false
    iswhere       =  " cd_compcode ='#{@compcodes}' AND id = '#{taskid}'"
    #iswhere       += " AND FIND_IN_SET('#{loguserid}',cd_readstatus)>0"
    updaterake    = TrnConversastionDetail.where(iswhere).first
    
  if updaterake
       rvtask = updaterake.cd_readstatus
       tskp   = ""
       if rvtask
             newtsk = rvtask.to_s.split(",")
             if newtsk.length >0
                   newtsk.each do |newks|
                       if loguserid.to_i != newks.to_i
                           tskp +=newks.to_s+","
                       end
                   end
                   if tskp
                     tskp = tskp.to_s.chop
                   end
             end
       end
      updaterake.update(:cd_readstatus=>tskp)
      istatus = true
  end

   mytesk  = TrnConversastionDetail.where("")
  respond_to do |format|
    format.json { render :json => { :status=>istatus,'data'=>'' } }
  end

end

private
def set_update_chat_message
     istatus  = false
     mycounts = 0
     chatsobj = get_chat_assign_user_notify()
     if chatsobj.length >0
       mycounts = chatsobj.length
       istatus  = true
       formdata = formatted_chat_notify(chatsobj)
     end
    respond_to do |format|
     format.json { render :json => { :status=>istatus,'data'=>formdata,'mycounts'=>mycounts } }
    end
end


private
def update_chat_review_task
    loguserid     =  session[:autherizedUserId]
    taskid        =  params[:taskid]
    istatus       =  false
    mycounts      =  0
    iswhere       =  " cd_compcode ='#{@compcodes}' AND cd_taskid = '#{taskid}'"
    iswhere       += " AND FIND_IN_SET('#{loguserid}',cd_readstatus)>0"
    updaterake    = TrnConversastionDetail.where(iswhere)

  if updaterake.length >0
       updaterake.each do |newcon|
         process_update_task_new(newcon.id)
       end
       
      istatus = true
  end
    iswheres  = " cd_compcode ='#{@compcodes}' AND FIND_IN_SET('#{loguserid}',cd_readstatus)>0"
    isselect  = "cd_readstatus,cd_taskid,id"
    myteskobj = TrnConversastionDetail.select(isselect).where(iswheres)
    if myteskobj.length >0
       mycounts = myteskobj.length
    end    
    respond_to do |format|
      format.json { render :json => { :status=>istatus,'data'=>myteskobj,'newmycounts'=>mycounts } }
    end

end

private
def process_update_task_new(convid)
      loguserid     =  session[:autherizedUserId]
      tskp          = ""
      iswhere       = " cd_compcode ='#{@compcodes}' AND id = '#{convid}'"
      updaterake    = TrnConversastionDetail.where(iswhere).first
       if updaterake
             rvtask = updaterake.cd_readstatus
             newtsk = rvtask.to_s.split(",")
             if newtsk.length >0
                   newtsk.each do |newks|
                       if loguserid.to_i != newks.to_i
                           tskp +=newks.to_s+","
                       end
                   end
                   if tskp
                     tskp = tskp.to_s.chop
                   end
             end
             updaterake.update(:cd_readstatus=>tskp)
       end     

end
  
end


