class VendorlistController < ApplicationController
  before_action :require_login
  before_action :allowed_pages
  before_action :is_allowed_location
  skip_before_action :verify_authenticity_token
  include ErpModule::Common
  helper_method :currency_formatted,:get_name_of_product,:year_month_days_formatted,:formatted_date
  helper_method :set_ent,:set_dct,:get_service_type_detail,:get_material_type_detail
  def index
    @compcodes  =  session[:loggedUserCompCode]    
    @postXParms = nil
    @MCustomer  = nil
    @Paths      = nil
    if session[:postedpamams]!=nil
        @postXParms = session[:postedpamams]
    end  
    if params[:identity]!='' && params[:identity]!=nil && params[:identity]=='Y'
          add_service_from_modal()
          return
     elsif params[:identity]!='' && params[:identity]!=nil && params[:identity]=='DL'
          delete_service_type()
          return
    end
    

    search()
    @Customers     = @xCustomers
    if @Customers.length >0
      printcontroll  = "1_vendor_register_report"
      @Paths         =  vendorlist_path(printcontroll,:format=>"pdf")
    end
    @totalCustOb  = MstCustomer.where("cs_compcode=? and cs_loc=?",@compcodes,@isLoc)
    if @totalCustOb.count >0
          session[:total_customers] = @totalCustOb.count
    else
        session[:total_customers] = 0
        redirect_to "#{root_url}vendorlist/add_customer"
    end

  end

  def add_customer
    #use if required now it is working as add customer
    @compcodes      = session[:loggedUserCompCode]
    @isAloc         = false
    @MCustomer      = nil
    @india          = 0
    if params[:id].to_i >0
       @MCustomer    =  MstCustomer.where("cs_compcode=? AND id=?",@compcodes,params[:id]).first
       cid           = @MCustomer.cs_country.to_i
    else
       cid           = '99'
    end
    @india           = cid
    #@serviceType    =  MstServiceType.where("sv_compcode =?",@compcodes).order("sv_name ASC")
    @matType        =  MstProductBrand.where("pb_compcode =?",@compcodes).order("pb_brandname ASC")
    @customerState  =  MstCompany.where(["cmp_companycode = ?", @compcodes]).first
    @Location       =  MstLocation.where("lc_compcode=?",@compcodes)
    @Countries      =  MstInqCountry.all.order("TRIM(country_name) ASC")
    @Mstdepart      =  MstPaymentTerm.all.order("TRIM(pts_description) ASC")
    
    @isXFlags       = false
    @companyState   = MstInqState.where(["cid = ?", cid]).order("state_name ASC")

    if @companyState
      @companyState.each do |isState|
        if isState.scid.to_i == @customerState.cmp_stateandcode.to_i
          @isXFlags = true
        end
      end
    end
    if @customerState
      if @customerState.cmp_multi_loc!=nil && @customerState.cmp_multi_loc!='' &&@customerState.cmp_multi_loc =='Y'
        @isAloc = true
      end
    end
    @grpName    = MstGroup.where(["gp_compcode = ?", @compcodes])
    @salesName  = MstSale.where(["sl_compcode = ?", @compcodes])
    @phoneCodes = MstInqCountry.select('country_code').where(["cid = ?", cid]).first
    @modulescon = MstModule.select('mds_factor,mds_debit').where(["mds_compcode = ?", @compcodes]).first

  end

  def search
    if params[:page].to_i >0
      @pages = params[:page]
    else
      @pages = 1
    end
    csledgertype    = params[:csledgertype]!=nil && params[:csledgertype]!='' ? params[:csledgertype] : session[:req_types]
    customername    = params[:customername]!=nil && params[:customername]!='' ? params[:customername] : session[:req_customer]
    customermobile  = params[:customermobile]!=nil && params[:customermobile]!='' ? params[:customermobile] : session[:req_customermob]
    iswhere         = "cs_compcode='#{@compcodes}'"
    if customername!=nil && customername!=''
        customernames = "%"+customername.to_s+"%"
        iswhere +=" AND cs_customername LIKE '#{customernames}'"
        @isCustName            = customername
        session[:req_customer] = customername

    end
    if customermobile!=nil && customermobile!=''
        customermobiles = "%"+customermobiles.to_s+"%"
        iswhere +=" AND cs_mobilenumber LIKE '#{customermobiles}'"
        @isCustMobl               = customermobile
        session[:req_customermob] = customermobile
    end
    if csledgertype!=nil && csledgertype!=''     
      iswhere +=" AND cs_ledgertype='#{csledgertype}'"
      @csledgertype       = csledgertype
      session[:req_types] = csledgertype
    end    
    isselect = "mst_customers.*,ist.state_name,cont.country_name,'' as materialtype,'' as vendcontype,'' as servicetype"
    jons = "LEFT JOIN mst_inq_states ist ON(ist.scid=mst_customers.cs_statecodename)"
    jons += "LEFT JOIN mst_inq_countries cont ON(cont.cid = mst_customers.cs_country)"
    
    @xCustomers = MstCustomer.select(isselect).joins(jons).where(iswhere).paginate(:page =>@pages,:per_page => 25).order('TRIM(cs_customername) ASC')
    
  end


  def print_all_search
    
    csledgertype    = params[:csledgertype]!=nil && params[:csledgertype]!='' ? params[:csledgertype] : session[:req_types]
    customername    = params[:customername]!=nil && params[:customername]!='' ? params[:customername] : session[:req_customer]
    customermobile  = params[:customermobile]!=nil && params[:customermobile]!='' ? params[:customermobile] : session[:req_customermob]
    iswhere         = "cs_compcode='#{@compcodes}'"
    if customername!=nil && customername!=''
        customernames = "%"+customername.to_s+"%"
        iswhere +=" AND cs_customername LIKE '#{customernames}'"
        @isCustName            = customername
        session[:req_customer] = customername

    end
    if customermobile!=nil && customermobile!=''
        customermobiles = "%"+customermobiles.to_s+"%"
        iswhere +=" AND cs_mobilenumber LIKE '#{customermobiles}'"
        @isCustMobl               = customermobile
        session[:req_customermob] = customermobile
    end
    if csledgertype!=nil && csledgertype!=''
      iswhere +=" AND cs_ledgertype='#{csledgertype}'"
      @csledgertype       = csledgertype
      session[:req_types] = csledgertype
    end
    isselect = "mst_customers.*,ist.state_name,cont.country_name,'' as materialtype,'' as vendcontype,'' as servicetype"
    jons = "LEFT JOIN mst_inq_states ist ON(ist.scid=mst_customers.cs_statecodename)"
    jons += "LEFT JOIN mst_inq_countries cont ON(cont.cid = mst_customers.cs_country)"
    printall  = MstCustomer.select(isselect).joins(jons).where(iswhere).order('TRIM(cs_customername) ASC')
    return printall
  end
  
  def create
    @compcodes  =  session[:loggedUserCompCode]
    @logedId    =  session[:autherizedUserId]
    isFlags     =  true
     mid        = params[:mid]
    begin
      if( params[:cs_ledgertype]=='cash' || params[:cs_ledgertype]=='bank' || params[:cs_ledgertype]=='expense' || params[:cs_ledgertype]=='card')
            if params[:cs_customername]=='' || params[:cs_customername]==nil
              flash[:error] =  "Please enter customer name!"
              isFlags =false
            elsif params[:cs_contactpersonname]=='' || params[:cs_contactpersonname]==nil
              flash[:error] =  "Please enter code"
            elsif @compcodes=='' || @compcodes==nil
              flash[:error] =  "Invalid company!"
              isFlags =false
            end
      else
            if params[:cs_customername]=='' || params[:cs_customername]==nil
              flash[:error] =  "Please enter customer name!"
              isFlags =false
            elsif params[:cs_contactpersonname]=='' || params[:cs_contactpersonname]==nil
              flash[:error] =  "Please enter code"
            elsif ( params[:cs_country]=='' || params[:cs_country]==nil )
              flash[:error] =  "Please select country name"
              isFlags =false
            elsif @compcodes=='' || @compcodes==nil
              flash[:error] =  "Invalid company!"
              isFlags =false
            end
      end
     
      if mid.to_i >0

        if isFlags
            if  mid.to_i <=0 && params[:cs_mobilenumber]!='' && params[:cs_mobilenumber]!=nil && params[:curmobileaddress].to_i != params[:cs_mobilenumber].to_i
              @isCustChk = MstCustomer.where("cs_compcode=? AND cs_mobilenumber=? and cs_loc=?",@compcodes,params[:cs_mobilenumber],@isLoc)
              if @isCustChk.count >0
                flash[:error] =  "This mobile number already taken,Please try another!"
                isFlags =false
              end
            end
        end
         if isFlags
             if mid.to_i <=0 && params[:cs_emailaddress]!='' && params[:cs_emailaddress]!=nil && params[:curemailaddress].to_s != params[:cs_emailaddress].to_s
                  @isCustChk = MstCustomer.where("cs_compcode=? AND cs_emailaddress=? and cs_loc=?",@compcodes,params[:cs_emailaddress],@isLoc)
                  if @isCustChk.count >0
                    flash[:error] =  "This email already taken,Please try another!"
                    isFlags =false
                  end
            end
         end

        if isFlags
          if mid.to_i <=0 && params[:cs_customername]!='' && params[:cs_customername]!=nil && params[:cs_gstnumber]!='' && params[:cs_gstnumber]!=nil
            names      = params[:cs_customername].to_s.delete(' ').upcase
            gstnumbs   = params[:cs_gstnumber].to_s.delete(' ').upcase
            curgstno   = (params[:currentgstno].to_s.delete(' ')).upcase
            curname    = (params[:currentnames].to_s.delete(' ')).upcase
            if curgstno!=gstnumbs && names != curname
              @iscustObj = MstCustomer.where("cs_compcode=? AND replace(UPPER(cs_customername),' ','')=? AND replace(UPPER(cs_gstnumber),' ','')=? and cs_loc=?",@compcodes,names,gstnumbs,@isLoc)
              if @iscustObj.count >0
                flash[:error] =  "This vendor name already exist, try another one!"
                isFlags =false
              end
            end
          end


        end
        if isFlags
            if params[:cs_gstnumber].to_s!='' && params[:cs_gstnumber].to_s!=nil
                  isGstId      = params[:cs_statecodename].to_i
                  isGstUse     = params[:cs_gstnumber].to_s.delete(' ')
                  isGst        = isGstUse[0,2]
                  @isStateCode = MstInqState.where("scid =?",isGstId).first
                  if @isStateCode
                    if isGst.to_s.delete(' ') != @isStateCode.tin_number.to_s.delete(' ')
                      isFlags =false
                      flash[:error] = "Invalid GST number you entered!"
                    end
                  end
            end
        end
          if isFlags
                
                mygstnumber  = params[:cs_gstnumber].to_s.delete(' ')
                currentgstno = params[:currentgstno].to_s.delete(' ')
                if mygstnumber!= currentgstno
                        @isGSTObj = MstCustomer.where("cs_compcode=? AND replace(cs_gstnumber,' ','')=? and cs_loc=?",@compcodes,mygstnumber,@isLoc)
                        if @isGSTObj.length >0
                             isFlags = false
                            flash[:error] =  "Duplicate GST number is not allowed."
                        end
                end
          end
       
          if isFlags
                customerid    =  mid.to_i
                @findCustomer =  MstCustomer.where("cs_compcode=? AND id=? and cs_loc=?",@compcodes,customerid,@isLoc).first
                @findCustomer.update(customers_params)
                flash[:error] = "Data updated successfully "
                isFlags       = true
          end
     
      else ##### NEW LEDGER

                if isFlags
                    if params[:cs_mobilenumber]!='' && params[:cs_mobilenumber]!=nil
                      @isCustChk = MstCustomer.where("cs_compcode=? AND replace(cs_mobilenumber,' ','')=? and cs_loc=?",@compcodes,params[:cs_mobilenumber].to_s.delete(' '),@isLoc)
                      if @isCustChk.count >0
                        flash[:error] =  "This mobile number already taken,Please try another!"
                        isFlags =false
                      end
                    end
                end
                  if isFlags
                        if params[:cs_emailaddress]!='' && params[:cs_emailaddress]!=nil
                          @isCustChk = MstCustomer.where("cs_compcode=? AND replace(cs_emailaddress,' ','')=? and cs_loc=?",@compcodes,params[:cs_emailaddress].to_s.delete(' '),@isLoc)
                          if @isCustChk.count >0
                            flash[:error] =  "This email already taken,Please try another!"
                            isFlags =false
                          end
                        end
                  end
                  if isFlags
                        if params[:cs_customername]!='' && params[:cs_customername]!=nil && params[:cs_gstnumber]!='' && params[:cs_gstnumber]!=nil && params[:cs_contactpersonname]!='' && params[:cs_contactpersonname]!=nil
                                names      = params[:cs_customername].to_s.delete(' ').upcase
                                gstnumbs   = params[:cs_gstnumber].to_s.delete(' ').upcase
                                contpersn  = params[:cs_contactpersonname].to_s.delete(' ').upcase
                                @iscustObj = MstCustomer.where("cs_compcode=? AND replace(UPPER(cs_customername),' ','')=? AND replace(UPPER(cs_gstnumber),' ','')=? AND replace(UPPER(cs_contactpersonname),' ','')=? and cs_loc=?",@compcodes,names,gstnumbs,contpersn,@isLoc)
                                if @iscustObj.count >0
                                  flash[:error] =  "This company name already exist, try another one!"
                                  isFlags =false
                                end
                        elsif params[:cs_customername]!='' && params[:cs_customername]!=nil &&  params[:cs_contactpersonname]!='' && params[:cs_contactpersonname]!=nil
                              names      = params[:cs_customername].to_s.delete(' ').upcase
                              contpersn  = params[:cs_contactpersonname].to_s.delete(' ').upcase
                              @iscustObj = MstCustomer.where("cs_compcode=? AND replace(UPPER(cs_customername),' ','')=? AND replace(UPPER(cs_contactpersonname),' ','')=? and cs_loc=?",@compcodes,names,contpersn,@isLoc)
                              if @iscustObj.count >0
                                flash[:error] =  "This company name already exist, try another one!"
                                isFlags =false
                              end
                        elsif params[:cs_customername]!='' && params[:cs_customername]!=nil && params[:cs_gstnumber]!='' && params[:cs_gstnumber]!=nil
                              names      = params[:cs_customername].to_s.delete(' ').upcase
                              gstnumbs   = params[:cs_gstnumber].to_s.delete(' ').upcase
                              @iscustObj = MstCustomer.where("cs_compcode=? AND replace(UPPER(cs_customername),' ','')=? AND replace(UPPER(cs_gstnumber),' ','')=? and cs_loc=?",@compcodes,names,gstnumbs,@isLoc)
                              if @iscustObj.count >0
                                flash[:error] =  "This company name already exist, try another one!"
                                isFlags =false
                              end
                        end

                  end
                 if isFlags
                          if params[:cs_gstnumber]!='' && params[:cs_gstnumber]!=nil
                            isgstid      = params[:cs_statecodename].to_i
                            isgstuse     = params[:cs_gstnumber].to_s.delete(' ')
                            x1           = 3
                            isGst        = isgstuse[0,2]
                                  @isStateCode = MstInqState.where("scid =?",isgstid).first
                                  if @isStateCode
                                          if isGst.to_s.delete(' ') != @isStateCode.tin_number.to_s.delete(' ')
                                            isFlags =false
                                            flash[:error] =  "Invalid GST number you entered!"
                                          end
                                  end
                                  if isFlags
                                      custname    = params[:cs_customername].to_s.delete(' ').downcase
                                      mygstnumber = params[:cs_gstnumber].to_s.delete(' ')
                                      @isGSTObj = MstCustomer.where("cs_compcode=? AND replace(cs_gstnumber,' ','')=? and cs_loc=?",@compcodes,mygstnumber,@isLoc)
                                      if @isGSTObj.length >0
                                          nsgstnumbers = @isGSTObj[0].cs_gstnumber.to_s.delete(' ')
                                          if mygstnumber == nsgstnumbers
                                            isFlags = false
                                            flash[:error] =  "Duplicate GST number is not allowed!!"
                                          end
                                      end
                                  end
                          end
                 end
                  if isFlags
                        @comp = MstCustomer.new(customers_params)
                        if @comp.save
                              @isTotalCustomer = MstCustomer.where("cs_compcode=? and cs_loc=?",@compcodes,@isLoc)
                              if @isTotalCustomer.count >0
                                session[:total_customers] = @isTotalCustomer.count;
                              end
                              flash[:error] =  "Data saved successfully."
                              isFlags = true
                        end
                  end

       end    
      


      if !isFlags
        session[:postedpamams] = params
        session[:isErrorhandled] = 1
      else
        session[:postedpamams] = nil
        session[:isErrorhandled] = nil
        session.delete(:postedpamams)
        session.delete(:isErrorhandled)
      end
      rescue Exception => exc
        flash[:error] =   "#{exc.message}"
        session[:isErrorhandled] = 1
        isFlags = false
      end
      
    if !isFlags
      if mid.to_i >0
         redirect_to "#{root_url}"+"vendorlist/add_customer/"+mid.to_s
      else
         redirect_to "#{root_url}"+"vendorlist/add_customer"
      end
    else
      redirect_to "#{root_url}"+"vendorlist"
    end
   
  end

  
  def search_vendorlist_refresh
    session[:postedpamams]    = nil
    session[:req_types]       = nil
    session[:req_customer]    = nil
    session[:req_customermob] = nil
    session[:isErrorhandled]  = nil
    session.delete(:postedpamams)
    session.delete(:isErrorhandled)
    redirect_to "#{root_url}"+"vendorlist"
  end

  def vendorlist_refresh
    session[:postedpamams]    = nil
    session[:req_types]       = nil
    session[:req_customer]    = nil
    session[:req_customermob] = nil
    session[:isErrorhandled]  = nil
    session.delete(:postedpamams)   
    session.delete(:isErrorhandled)
    redirect_to "#{root_url}"+"vendorlist/add_customer"
  end
  def show    
      @compcodes     =  session[:loggedUserCompCode]
      @isAloc        =  false
      @compDetail    =  MstCompany.where(["cmp_companycode = ?", @compcodes]).first
      allcustomers   =  print_all_search()
      arrs           = []
      if allcustomers!=nil && allcustomers.length >0
          allcustomers.each do |vend|
             compcoes       = vend.cs_compcode
             matobj         = get_material_type_detail(compcoes,vend.cs_material_type)
             if matobj
               vend.materialtype = matobj.pb_description
             end             
             
             types = ''
             if vend.cs_ledgertype=='customer'
               types = 'Customer'
            elsif vend.cs_ledgertype=='buyer'
              types = 'Buyer'
            elsif vend.cs_ledgertype=='vendor'
              types = 'Supplier'
            elsif vend.cs_ledgertype=='cash'
              types = 'Cash'
            elsif vend.cs_ledgertype=='bank'
              types = 'Bank'
            elsif vend.cs_ledgertype=='serviceprovider'
              types = 'Contractor'
            end
            vend.vendcontype = types
            arrs.push vend
          end
      end
      

      if arrs.length >0
            @isXProd = arrs
              respond_to do |format|
                  format.html
                    format.pdf do
                        pdf = VedorregistorPdf.new(@isXProd,@isCustState,@isShipto,@compDetail,@cstType,@rootUrl,@isProforma,@isTakeTax,session,'')
                        send_data pdf.render,:filename => "1_vendor_register_report.pdf", :type => "application/pdf", :disposition => "inline"
                    end
               end
      end
  end

  def destroy
    customerid     =  params[:id].to_i
    @compcodes     =  session[:loggedUserCompCode]
    @customerId    =  customerid
    check_customer_exist
    if @isDelFlags
        flash[:error]             =  "Sorry!! Unable to delete this record due to somewhere being used."
        session[:isErrorhandled]  = 1
    else
        @MstCustomer   =  MstCustomer.where("cs_compcode = ? AND id = ?",@compcodes,customerid).first
        if @MstCustomer
            @MstCustomer.destroy
            flash[:error]            =  "Data successfully deleted!"
            session[:isErrorhandled] = nil
        end
    end
    redirect_to "#{root_url}"+"vendorlist"
  end

  private
  def delete_service_type
     mid       = params[:mid]
     isflags   = false
     msgs      = ''
     svtpeobj  = MstServiceType.where("sv_compcode=? AND id =?",@compcodes,mid).first
     if svtpeobj
       svtpeobj.destroy
       msgs = "Data deleted successfully."
       isflags = true
     end
     svobjs = MstServiceType.select('sv_name,id').where("sv_compcode = ?",@compcodes).order("sv_name ASC")
      respond_to do |format|
        format.json { render :json => { 'data'=>svobjs, "message"=>msgs,:status=>isflags } }
      end
  end

  private
  def add_service_from_modal
    gpname    = params[:names].to_s.strip
    currname  = params[:curr_names].to_s.strip
    mid       = params[:mid]
    isflags   = true
    if mid.to_i >0
      if isflags
          if gpname!=currname
                svtpeobj  = MstServiceType.where("sv_compcode=? AND LOWER(sv_name)=?",@compcodes,gpname.downcase)
                if  svtpeobj.length >0
                    msgs    =  "Your enter service type already taken!, try another one!"
                    isflags =  false
                end
          end
      end
       if isflags
         svupobj  = MstServiceType.where("sv_compcode =? AND id=?",@compcodes,mid).first
         if svupobj
           svupobj.update(service_params)
           msgs    =  "Data updated successfully."
           isflags =  true
         end
       end
    else
        if isflags
            svtpeobj  = MstServiceType.where("sv_compcode=? AND LOWER(sv_name)=?",@compcodes,gpname.downcase)
            if  svtpeobj.length >0
                msgs    =  "Your enter service type already taken!, try another one!"
                isflags =  false
            end
        end
        if isflags
          svsob = MstServiceType.new(service_params)
           if svsob.save
              msgs    =  "Data saved successfully."
             isflags =  true
           end
        end
    end
    
      svobjs = MstServiceType.select('sv_name,id').where("sv_compcode = ?",@compcodes).order("sv_name ASC")
      respond_to do |format|
        format.json { render :json => { 'data'=>svobjs, "message"=>msgs,:status=>isflags } }
      end
      
  end

  


  private
  def service_params
      params[:sv_compcode] = session[:loggedUserCompCode]
      params[:sv_name]     = params[:names].to_s.strip
      params.permit(:sv_compcode,:sv_name)
  end

  

  private
  def customers_params
    compcodes = session[:loggedUserCompCode]
    params[:cs_compcode] = compcodes
    ncb  = 0
    nccb = 0
    if params[:cs_yobamount]=='' || params[:cs_yobamount]==nil
      params[:cs_yobamount] = 0
    end
    if params[:cs_cbamount]=='' || params[:cs_cbamount]==nil
      params[:cs_cbamount] = 0
    end
    if params[:cs_opening_bal]=='' || params[:cs_opening_bal]==nil
      params[:cs_opening_bal] = 0
    end
    if params[:cs_closing_bal]=='' || params[:cs_closing_bal]==nil
      params[:cs_closing_bal] = 0
    end

    if params[:cs_telephonenumbers]=='' || params[:cs_telephonenumbers]==nil
      params[:cs_telephonenumbers] = 0
    end
    if params[:cs_creditdays]=='' || params[:cs_creditdays]==nil
      params[:cs_creditdays] = 0
    end
    if params[:cs_creditlimit]=='' || params[:cs_creditlimit]==nil
      params[:cs_creditlimit] = 0
    end

    if params[:cs_salesman]=='' || params[:cs_salesman]==nil
      params[:cs_salesman] = 0
    end
    if params[:cs_billingpin]=='' || params[:cs_billingpin]==nil
      params[:cs_billingpin] = 0
    end
    if params[:cs_shippingpin]=='' || params[:cs_shippingpin]==nil
      params[:cs_shippingpin] = 0
    end

    if params[:cs_pannumber]=='' || params[:cs_pannumber]==nil
      params[:cs_pannumber] = ''
    end
    if params[:cs_factor]=='' || params[:cs_factor]==nil
      params[:cs_factor] = 0
    end
    if params[:cs_debit]=='' || params[:cs_debit]==nil
      params[:cs_debit] = 0
    end
    if params[:isCustomersId].to_i!='' && params[:isCustomersId].to_i!=nil && params[:isCustomersId].to_i >0
      cb   = params[:currentcb].to_f
      nyob = params[:cs_yobamount].to_f
      oyob = params[:currentyob].to_f
      ncb = (cb-oyob)+nyob
    end
    if params[:isCustomersId].to_i!='' && params[:isCustomersId].to_i!=nil && params[:isCustomersId].to_i >0
      ccb   = params[:currentccb].to_f
      nyoob = params[:cs_opening_bal].to_f
      oyoob = params[:currentyoob].to_f
      nccb  = (ccb-oyoob)+nyoob
    end

    if ncb >0
      params[:cs_cbamount] = ncb
    end
    if nccb >0
      params[:cs_closing_bal] = nccb
    end

    if params[:cs_morephone]=='' || params[:cs_morephone]==nil
      params[:cs_morephone] = ''
    end
    if params[:cs_website]=='' || params[:cs_website]==nil
      params[:cs_website] = ''
    end
    if params[:cs_more_email]=='' || params[:cs_more_email]==nil
      params[:cs_more_email] = ''
    end
    if params[:cs_statecodename]==nil || params[:cs_statecodename]==''
      params[:cs_statecodename] = 0
    end
    if params[:cs_groupname]=='' || params[:cs_groupname]==nil
      params[:cs_groupname] = 0
    end
    if params[:cs_country]=='' || params[:cs_country]==nil
      params[:cs_country] = 0
    end
    params[:cs_groupname]         = 0
    params[:cs_customername]      = params[:cs_customername].to_s.strip
    params[:cs_contactpersonname] = params[:cs_contactpersonname].to_s.strip
    params[:cs_loc]               = session[:autherizedLoc]  ? session[:autherizedLoc] : 0
    params[:cs_job_works]         = params[:cs_job_works]!='' && params[:cs_job_works]!=nil ? params[:cs_job_works] : ''

    params[:cs_accountno]         = params[:cs_accountno]!='' && params[:cs_accountno]!=nil ? params[:cs_accountno] : ''
    params[:cs_bank_name]         = params[:cs_bank_name]!='' && params[:cs_bank_name]!=nil ? params[:cs_bank_name] : ''
    params[:cs_branch_address]    = params[:cs_branch_address]!='' && params[:cs_branch_address]!=nil ? params[:cs_branch_address] : ''
    params[:cs_ifsc_code]         = params[:cs_ifsc_code]!='' && params[:cs_ifsc_code]!=nil ? params[:cs_ifsc_code] : ''
    params[:cs_swift_code]        = params[:cs_swift_code]!='' && params[:cs_swift_code]!=nil ? params[:cs_swift_code] : ''

    params[:cs_payment_terms]     = params[:cs_payment_terms]!='' && params[:cs_payment_terms]!=nil ? params[:cs_payment_terms] : ''
    params[:cs_freight]           = params[:cs_freight]!='' && params[:cs_freight]!=nil ? params[:cs_freight] : ''
    params[:cs_city]              = params[:cs_city]!='' && params[:cs_city]!=nil ? params[:cs_city] : ''    
    params[:cs_material_type]     = params[:cs_material_type]!='' && params[:cs_material_type]!=nil ? params[:cs_material_type] : 0
    params[:cs_service_type]      = params[:cs_service_type]!='' && params[:cs_service_type]!=nil ? params[:cs_service_type] : 0
    params.permit(:cs_compcode,:cs_material_type,:cs_service_type,:cs_city,:cs_payment_terms,:cs_freight,:cs_swift_code,:cs_ifsc_code,:cs_branch_address,:cs_bank_name,:cs_accountno,:cs_country,:cs_job_works,:cs_customername,:cs_contactpersonname,:cs_billingaddress,:cs_billingaddress1,:cs_billingpin,:cs_shippingaddress,:cs_shippingaddress1,:cs_shippingpin,:cs_statecodename,:cs_yobamount,:cs_cbamount,:cs_telephonenumbers,:cs_creditdays,:cs_creditlimit,:cs_salesman,:cs_mobilenumber,:cs_emailaddress,:cs_groupname,:cs_gstnumber,:cs_privatemark,:cs_bankers,:cs_transport,:cs_codelocality,:cs_ledgertype,:cs_morephone,:cs_pannumber,:cs_factor,:cs_debit,:cs_website,:cs_opening_bal,:cs_closing_bal,:cs_more_email,:cs_loc)
  end

  private
  def check_customer_exist
    @isDelFlags = false
    @isItems    = TrnHdr.select('trn_hdrs.id').where("hd_compcode = ? AND hd_customer_id = ? AND hd_loc=?",@compcodes,@customerId,@isLoc)
    if  @isItems.length >0
       @isDelFlags = true
    end
    @delPoobj = TrnPurchaseWorkOrder.where("qt_compcode= ? AND qt_customers = ?",@compcodes,@customerId)
    if @delPoobj.length >0
        @isDelFlags = true
    end

    @delMrnobj = TrnMaterialReceiveNote.where("mcn_compcode = ? AND mcn_supplier_id = ?",@compcodes,@customerId)
    if @delMrnobj.length >0
        @isDelFlags = true
    end
    
    @delControbj = TrnContract.where("ct_compcode = ? AND ct_serviceprov_id = ?",@compcodes,@customerId)
    if @delControbj.length >0
        @isDelFlags = true
    end

    @delPmtobj = TrnPaymentHead.where("ph_compcode = ? AND ph_supplier = ?",@compcodes,@customerId)
    if @delPmtobj.length >0
        @isDelFlags = true
    end

    @delVendPmtobj = TrnContractorPayment.where("cps_compcode= ? AND cps_contractor = ?",@compcodes,@customerId)
    if @delVendPmtobj.length >0
        @isDelFlags = true
    end
    @delAssnobj = TrnAssignSite.where("(ast_compcode = ? AND ast_supervisor = ? OR ast_compcode = ? AND ast_security = ? ) ",@compcodes,@customerId,@compcodes,@customerId)
    if @delAssnobj.length >0
        @isDelFlags = true
    end 

    
  end

  private
  def get_state_by_country
      scid    = params[:cId]!=nil && params[:cId]!='' ? params[:cId]: 0
      items   = []
      isflg   = false
      issate  = MstInqState.where("cid=?",scid).order("TRIM(state_name) ASC")
      if issate.length >0
          items = issate
          msg   = "success"
          isflg = true
      end
      respond_to do |format|
        format.json { render :json => { 'data'=>items, "message"=>msg,"isFls"=>"",:status=>isflg } }
      end
  end

private
def get_agent_user
  isagentobj = MstSale.select("sl_name,id").where("sl_compcode=?",@compcodes).order("TRIM(sl_name) ASC")
  return isagentobj
end

private
def get_employee_user
  isagentobj = MstEmployee.select("emp_name as sl_name,id").where("emp_compcode=?",@compcodes).order("TRIM(emp_name) ASC")
  return isagentobj
end

private
def update_approval_enquery
    enqid        =  params[:enqid]!=nil && params[:enqid]!='' ? params[:enqid]: 0
    status       =  params[:status]!=nil && params[:status]!='' ? params[:status]: 'N'
    apid         =  params[:apprv_by]!=nil && params[:apprv_by]!='' ? params[:apprv_by]: 0
    rmks         =  params[:apprv_rmk]!=nil && params[:apprv_rmk]!='' ? params[:apprv_rmk]: ''
    apprvallist  =  TrnEnquiry.where("id=? AND enq_compcode=?",enqid,@compcodes).first
    flags = false
    if apprvallist
      apprvallist.update(:enq_status=>status,:enq_approved_by=>apid,:enq_approved_rmk=>rmks)
      flags = true
    end
    respond_to do |format|
      format.json { render :json => { 'data'=>'', "message"=>"success",:status=>flags } }
    end

end

end
